class DataParser {
  static parse(text) {
    if (!text) {
      alert("no text in file");
      return [];
    }
    let out = [];
    let split = text.split(/\r?\n/).filter((t) => !!t); // empty lines removed
    let rowLength = split[0].trim().split(/\s+/).length;
    let lCo = 0;
    for (let line of split) {
      lCo++;
      let lSplit = line.trim().split(/\s+/);
      if (lSplit.length !== rowLength) {
        alert("missing value in text file at line " + lCo);
      }
      out.push(lSplit);
    }
    return out;
  }
  static transformData(data) {
    let rowLength = data[0].length;
    for (let d of data.slice(1)) {
      d[0] = moment
        .tz(d[0], "YYYY-MM-DD_HH:mm:ss.SSS", "Europe/Berlin")
        .toDate();
      for (let i = 1; i < rowLength; i++) d[i] = parseFloat(d[i]);
      d[3] *= 8;
      d[4] *= 8;
      d[5] *= 8;
    }
    let newData = data.map((d) => [d[0], ...d.slice(3)]);
    newData = [
      [...newData[0].slice(0, 4), "mg", ...newData[0].slice(4)],
      ...newData
        .slice(1)
        .map((d) => [
          ...d.slice(0, 4),
          Math.round(Math.sqrt(d[1] * d[1] + d[2] * d[2] + d[3] * d[3])),
          ...d.slice(4),
        ]),
    ];

    return {
      data: newData,
      alarmData: data.map((d) => [d[0], d[2]]),
    };
  }
}
