class Plotter {}

const colors = [
  "#00FFFF",
  "#00AAFF",
  "#00007F",
  "#AAAA00",
  "#FFAA00",
  "#AA0000",
  "#55FF00",
  "#55FF7F",
];

let mainData = null;
$(document).ready(function () {
  init();

  // testPlot();
  $("#fileUpload").on("change", function (e) {
    let reader = new FileReader();
    console.log("reading", e.target.files[0].name);
    reader.onload = function (e) {
      let data = parseCsv(e.target.result);
      mainData = transformData(data);
      initCsvHeaderForm();
      plotAll();
      // console.log("data", data);
    };
    reader.readAsText(e.target.files[0]);
  });
}); /// END document.ready

function init() {
  Chart.pluginService.register({
    beforeDraw: function (chart, easing) {
      console.log(chart);
    },
  });
}

function plotAll() {
  let header = mainData[0];
  for (let i = 3; i < header.length; i++) {
    let plotData = mainData.slice(1).map((d) => {
      return { x: d[0], y: d[i] };
    });
    // console.log(plotData);
    // console.log(mainData);
    let ctx = document.getElementById("cv" + i).getContext("2d");
    let myChart = new Chart(ctx, {
      type: "line",
      data: {
        // labels: ["Red", "Blue", "Yellow", "Green", "Purple", "Orange"],
        datasets: [
          {
            label: header[i],
            data: plotData,
            backgroundColor: $(`#col${i}color`).css("background-color"),
            lineTension: 0,
            borderColor: $(`#col${i}color`).css("background-color"),
            fill: false,
          },
        ],
      },
      options: {
        scales: {
          xAxes: [
            {
              // display: true,
              type: "linear",
              scaleLabel: {
                // display: true,
                labelString: "time",
              },
              ticks: { display: false },
            },
          ],
        },
        maintainAspectRatio: false,
        // legend: { display: false },
      },
      tooltips: {
        enabled: false,
      },
    });
    myChart.chartArea.left = 60;
    ctx.restore();
    // console.log(());
  }
}

function testPlot() {
  let plotData = [
    { x: 1, y: 1 },
    { x: 1.5, y: 2 },
    { x: 2.5, y: 6 },
  ];
  // console.log(mainData);
  for (let i = 1; i < 3; i++) {
    let ctx = document.getElementById("cv" + i).getContext("2d");
    let myChart = new Chart(ctx, {
      type: "line",
      data: {
        // labels: ["Red", "Blue", "Yellow", "Green", "Purple", "Orange"],
        datasets: [
          {
            label: "Bx",
            data: plotData,
            backgroundColor: "blue",
            lineTension: 0,
            borderColor: "blue",
            fill: false,
          },
        ],
        // labels: plotData.map((d) => d.x),
      },
      options: {
        scales: {
          xAxes: [
            {
              // display: true,
              type: "linear",
              scaleLabel: {
                // display: true,
                labelString: "time",
              },
              ticks: { display: false },
            },
          ],
        },
        maintainAspectRatio: false,
        legend: { display: false },
      },
      // options: {
      //   scales: {
      //     yAxes: [
      //       {
      //         ticks: {
      //           beginAtZero: true,
      //         },
      //       },
      //     ],
      //   },
      // },
    });
    // console.log(myChart);
  }
}

function initCsvHeaderForm() {
  let header = mainData[0];
  for (let i = 3; i < header.length; i++) {
    $("#form").append(`
      <div class="col-auto mb-3">
        <div class="input-group">
          <div
            class="input-group-prepend"
            style="background-color: ${
              colors[i - 3] ||
              "#" + Math.floor(Math.random() * 16777215).toString(16)
            }; width: 50px"
            id="col${i}color"
          ></div>
          <div class="input-group-append">
            <div class="input-group-text" id="col${i}makePlot">
              <div class="row">
                <div class="col-6">${header[i]}</div>
                <div class="col-6">
                  <input type="checkbox" id="plotCol${i}" checked="true"/>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>`);
    $("#plotArea").append(`
        <div class="row" id="plot${i}">
          <canvas id="cv${i}" height="200"></canvas>
        </div>
      `);

    $(`#col${i}color`).click(function () {
      alert("ok");
    });
    $(`#col${i}makePlot`).click(function (e) {
      if (e.target.id === `plotCol${i}`) return;
      $(`#plotCol${i}`).prop("checked", !$(`#plotCol${i}`).is(":checked"));
      $(`#plotCol${i}`).trigger("change");
    });
    $(`#plotCol${i}`).change(function () {
      // console.log(this.checked);
      if (this.checked) {
        $(`#plot${i}`).show();
      } else {
        $(`#plot${i}`).hide();
      }
    });
  }
}
